use std::{error::Error, fmt::Display};

#[derive(Debug)]
pub enum RaTlsError {
    CertificateBuildError(String),
    QuoteError(String),
    DcapError(String),
}

impl Display for RaTlsError {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        match *self {
            RaTlsError::CertificateBuildError(ref message) => {
                write!(f, "CertificateBuildError: {}", message)
            }
            RaTlsError::QuoteError(ref message) => write!(f, "QuoteVerifyError: {}", message),
            RaTlsError::DcapError(ref message) => write!(f, "DcapError: {}", message),
        }
    }
}

impl Error for RaTlsError {}
